/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the ManagedResourceType type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ManagedResourceType{}

// ManagedResourceType struct for ManagedResourceType
type ManagedResourceType struct {
	ResourceTypeName    string         `json:"resourceTypeName"`
	BlockGracePeriod    NullableInt32  `json:"blockGracePeriod,omitempty"`
	ArchiveGracePeriod  NullableInt32  `json:"archiveGracePeriod,omitempty"`
	DeleteGracePeriod   NullableInt32  `json:"deleteGracePeriod,omitempty"`
	LifecycleSettingsId *string        `json:"lifecycleSettingsId,omitempty"`
	InitialState        *ResourceState `json:"initialState,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _ManagedResourceType ManagedResourceType

// NewManagedResourceType instantiates a new ManagedResourceType object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewManagedResourceType(resourceTypeName string) *ManagedResourceType {
	this := ManagedResourceType{}
	this.ResourceTypeName = resourceTypeName
	return &this
}

// NewManagedResourceTypeWithDefaults instantiates a new ManagedResourceType object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewManagedResourceTypeWithDefaults() *ManagedResourceType {
	this := ManagedResourceType{}
	return &this
}

// GetResourceTypeName returns the ResourceTypeName field value
func (o *ManagedResourceType) GetResourceTypeName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ResourceTypeName
}

// GetResourceTypeNameOk returns a tuple with the ResourceTypeName field value
// and a boolean to check if the value has been set.
func (o *ManagedResourceType) GetResourceTypeNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ResourceTypeName, true
}

// SetResourceTypeName sets field value
func (o *ManagedResourceType) SetResourceTypeName(v string) {
	o.ResourceTypeName = v
}

// GetBlockGracePeriod returns the BlockGracePeriod field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResourceType) GetBlockGracePeriod() int32 {
	if o == nil || IsNil(o.BlockGracePeriod.Get()) {
		var ret int32
		return ret
	}
	return *o.BlockGracePeriod.Get()
}

// GetBlockGracePeriodOk returns a tuple with the BlockGracePeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResourceType) GetBlockGracePeriodOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockGracePeriod.Get(), o.BlockGracePeriod.IsSet()
}

// HasBlockGracePeriod returns a boolean if a field has been set.
func (o *ManagedResourceType) HasBlockGracePeriod() bool {
	if o != nil && o.BlockGracePeriod.IsSet() {
		return true
	}

	return false
}

// SetBlockGracePeriod gets a reference to the given NullableInt32 and assigns it to the BlockGracePeriod field.
func (o *ManagedResourceType) SetBlockGracePeriod(v int32) {
	o.BlockGracePeriod.Set(&v)
}

// SetBlockGracePeriodNil sets the value for BlockGracePeriod to be an explicit nil
func (o *ManagedResourceType) SetBlockGracePeriodNil() {
	o.BlockGracePeriod.Set(nil)
}

// UnsetBlockGracePeriod ensures that no value is present for BlockGracePeriod, not even an explicit nil
func (o *ManagedResourceType) UnsetBlockGracePeriod() {
	o.BlockGracePeriod.Unset()
}

// GetArchiveGracePeriod returns the ArchiveGracePeriod field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResourceType) GetArchiveGracePeriod() int32 {
	if o == nil || IsNil(o.ArchiveGracePeriod.Get()) {
		var ret int32
		return ret
	}
	return *o.ArchiveGracePeriod.Get()
}

// GetArchiveGracePeriodOk returns a tuple with the ArchiveGracePeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResourceType) GetArchiveGracePeriodOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveGracePeriod.Get(), o.ArchiveGracePeriod.IsSet()
}

// HasArchiveGracePeriod returns a boolean if a field has been set.
func (o *ManagedResourceType) HasArchiveGracePeriod() bool {
	if o != nil && o.ArchiveGracePeriod.IsSet() {
		return true
	}

	return false
}

// SetArchiveGracePeriod gets a reference to the given NullableInt32 and assigns it to the ArchiveGracePeriod field.
func (o *ManagedResourceType) SetArchiveGracePeriod(v int32) {
	o.ArchiveGracePeriod.Set(&v)
}

// SetArchiveGracePeriodNil sets the value for ArchiveGracePeriod to be an explicit nil
func (o *ManagedResourceType) SetArchiveGracePeriodNil() {
	o.ArchiveGracePeriod.Set(nil)
}

// UnsetArchiveGracePeriod ensures that no value is present for ArchiveGracePeriod, not even an explicit nil
func (o *ManagedResourceType) UnsetArchiveGracePeriod() {
	o.ArchiveGracePeriod.Unset()
}

// GetDeleteGracePeriod returns the DeleteGracePeriod field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResourceType) GetDeleteGracePeriod() int32 {
	if o == nil || IsNil(o.DeleteGracePeriod.Get()) {
		var ret int32
		return ret
	}
	return *o.DeleteGracePeriod.Get()
}

// GetDeleteGracePeriodOk returns a tuple with the DeleteGracePeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResourceType) GetDeleteGracePeriodOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteGracePeriod.Get(), o.DeleteGracePeriod.IsSet()
}

// HasDeleteGracePeriod returns a boolean if a field has been set.
func (o *ManagedResourceType) HasDeleteGracePeriod() bool {
	if o != nil && o.DeleteGracePeriod.IsSet() {
		return true
	}

	return false
}

// SetDeleteGracePeriod gets a reference to the given NullableInt32 and assigns it to the DeleteGracePeriod field.
func (o *ManagedResourceType) SetDeleteGracePeriod(v int32) {
	o.DeleteGracePeriod.Set(&v)
}

// SetDeleteGracePeriodNil sets the value for DeleteGracePeriod to be an explicit nil
func (o *ManagedResourceType) SetDeleteGracePeriodNil() {
	o.DeleteGracePeriod.Set(nil)
}

// UnsetDeleteGracePeriod ensures that no value is present for DeleteGracePeriod, not even an explicit nil
func (o *ManagedResourceType) UnsetDeleteGracePeriod() {
	o.DeleteGracePeriod.Unset()
}

// GetLifecycleSettingsId returns the LifecycleSettingsId field value if set, zero value otherwise.
func (o *ManagedResourceType) GetLifecycleSettingsId() string {
	if o == nil || IsNil(o.LifecycleSettingsId) {
		var ret string
		return ret
	}
	return *o.LifecycleSettingsId
}

// GetLifecycleSettingsIdOk returns a tuple with the LifecycleSettingsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResourceType) GetLifecycleSettingsIdOk() (*string, bool) {
	if o == nil || IsNil(o.LifecycleSettingsId) {
		return nil, false
	}
	return o.LifecycleSettingsId, true
}

// HasLifecycleSettingsId returns a boolean if a field has been set.
func (o *ManagedResourceType) HasLifecycleSettingsId() bool {
	if o != nil && !IsNil(o.LifecycleSettingsId) {
		return true
	}

	return false
}

// SetLifecycleSettingsId gets a reference to the given string and assigns it to the LifecycleSettingsId field.
func (o *ManagedResourceType) SetLifecycleSettingsId(v string) {
	o.LifecycleSettingsId = &v
}

// GetInitialState returns the InitialState field value if set, zero value otherwise.
func (o *ManagedResourceType) GetInitialState() ResourceState {
	if o == nil || IsNil(o.InitialState) {
		var ret ResourceState
		return ret
	}
	return *o.InitialState
}

// GetInitialStateOk returns a tuple with the InitialState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResourceType) GetInitialStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InitialState) {
		return nil, false
	}
	return o.InitialState, true
}

// HasInitialState returns a boolean if a field has been set.
func (o *ManagedResourceType) HasInitialState() bool {
	if o != nil && !IsNil(o.InitialState) {
		return true
	}

	return false
}

// SetInitialState gets a reference to the given ResourceState and assigns it to the InitialState field.
func (o *ManagedResourceType) SetInitialState(v ResourceState) {
	o.InitialState = &v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResourceType) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResourceType) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *ManagedResourceType) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *ManagedResourceType) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *ManagedResourceType) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *ManagedResourceType) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *ManagedResourceType) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResourceType) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *ManagedResourceType) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *ManagedResourceType) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o ManagedResourceType) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ManagedResourceType) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["resourceTypeName"] = o.ResourceTypeName
	if o.BlockGracePeriod.IsSet() {
		toSerialize["blockGracePeriod"] = o.BlockGracePeriod.Get()
	}
	if o.ArchiveGracePeriod.IsSet() {
		toSerialize["archiveGracePeriod"] = o.ArchiveGracePeriod.Get()
	}
	if o.DeleteGracePeriod.IsSet() {
		toSerialize["deleteGracePeriod"] = o.DeleteGracePeriod.Get()
	}
	if !IsNil(o.LifecycleSettingsId) {
		toSerialize["lifecycleSettingsId"] = o.LifecycleSettingsId
	}
	if !IsNil(o.InitialState) {
		toSerialize["initialState"] = o.InitialState
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *ManagedResourceType) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"resourceTypeName",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varManagedResourceType := _ManagedResourceType{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varManagedResourceType)

	if err != nil {
		return err
	}

	*o = ManagedResourceType(varManagedResourceType)

	return err
}

type NullableManagedResourceType struct {
	value *ManagedResourceType
	isSet bool
}

func (v NullableManagedResourceType) Get() *ManagedResourceType {
	return v.value
}

func (v *NullableManagedResourceType) Set(val *ManagedResourceType) {
	v.value = val
	v.isSet = true
}

func (v NullableManagedResourceType) IsSet() bool {
	return v.isSet
}

func (v *NullableManagedResourceType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableManagedResourceType(val *ManagedResourceType) *NullableManagedResourceType {
	return &NullableManagedResourceType{value: val, isSet: true}
}

func (v NullableManagedResourceType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableManagedResourceType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
